# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests

%global pypi_name drgn

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:        0.0.32+38.gfba8f1d5
Release:        1.20250703232953510831.main.38.gfba8f1d5%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        drgn-0.0.32+38.gfba8f1d5.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
%if %{with docs}
BuildRequires:  sed
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-docs
BuildRequires:  graphviz
%endif
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  elfutils-debuginfod-client-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}
Recommends:     elfutils-debuginfod-client

%description -n %{pypi_name} %{_description}

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python3-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%autosetup -n drgn-0.0.32+38.gfba8f1d5 -p1
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
# verbose build
V=1 %py3_build

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn

%if %{with tests}
%check
%pytest
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/_%{pypi_name}_util
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%changelog
* Thu Jul 03 2025 Packit <hello@packit.dev> - 0.0.32+38.gfba8f1d5-1.20250703232953510831.main.38.gfba8f1d5
- contrib: add pstack.py script to print kernel + user stack (Stephen Brennan)
- helpers: linux: pid: add for_each_task_in_group() (Stephen Brennan)
- crash: add mount command (Omar Sandoval)
- Add crash compatibility mode (Omar Sandoval)
- Add command framework (Omar Sandoval)
- drgndoc: store value of variables (Omar Sandoval)
- _drgn_util: add argparse help formatter that supports multiple lines (Omar Sandoval)
- _drgn_util.typingutils: add decorators for copying function/method signatures (Omar Sandoval)
- scripts/build_manylinux_in_docker.sh: remove aclocal workaround (Omar Sandoval)
- drgn.helpers.linux.printk: fix code style (Omar Sandoval)
- tests: add kernfs_children() test (Joanne Koong)
- drgn.helpers.linux.kernfs: add kernfs_children() helper (Joanne Koong)
- packit: drop EPEL 8 (Omar Sandoval)
- docs: remove validators from user guide (Omar Sandoval)
- python: use typing.SupportsIndex as IntegerLike (Omar Sandoval)
- _drgn.pyi: drop typing_extensions fallbacks for Python 3.6/3.7 (Omar Sandoval)
- tests: drop class cleanup fallback for Python 3.6/3.7 (Omar Sandoval)
- Drop typing.Literal fallbacks for Python 3.6/3.7 (Omar Sandoval)
- execscript: drop io.open_code() fallback for Python 3.6/3.7 (Omar Sandoval)
- Revert "tests: skip timekeeping tests using time.clock_gettime_ns() on Python 3.6" (Omar Sandoval)
- tests: drop Python 3.6/3.7 fallback for unittest.mock.create_autospec() (Omar Sandoval)
- contrib/btrfs_tree.py: drop Python 3.6 workaround for _BtrfsItemHandler (Omar Sandoval)
- drgndoc: use dataclasses (Omar Sandoval)
- drgndoc: drop Python 3.7 fallback for old ast constant nodes (Omar Sandoval)
- drgndoc.docstrings: drop Python 3.6 const char fallback (Omar Sandoval)
- python: drop Py_UNREACHABLE() and Py_RETURN_RICHCOMPARE() definitions for Python 3.6 (Omar Sandoval)
- python: drop PyEval_InitThreads() call for Python 3.6 (Omar Sandoval)
- python: drop Python 3.6 fallback for PyMapping_Items() returning a tuple (Omar Sandoval)
- python: drop Python 3.6 fallback for logging hack (Omar Sandoval)
- python: drop Python 3.6 fallback for _PyObject_GenericGetAttrWithDict() (Omar Sandoval)
- plugins: drop pkg_resources fallback for Python 3.6/3.7 (Omar Sandoval)
- Officially drop Python 3.6 and 3.7 support (Omar Sandoval)
- drgndoc: fix type alias annotation workaround (Omar Sandoval)
- tests: fix ResourceWarning in test_for_each_module() (Omar Sandoval)
- CI: add Python 3.14 (Omar Sandoval)
- python: use public version of Py_HashPointer() on Python 3.14 (Omar Sandoval)
- tests: fix "can't pickle local object" errors on Python 3.14 (Omar Sandoval)
- Enhance get_dmesg() and print_dmesg() (Yassine Larhrissi)
